import ur, { useMemo as Se, createElement as Zr, useEffect as cr, createContext as Qr, useReducer as et, useCallback as fr, useContext as rt } from "react";
var lr = Symbol.for("immer-nothing"), rr = Symbol.for("immer-draftable"), m = Symbol.for("immer-state"), tt = process.env.NODE_ENV !== "production" ? [
  // All error codes, starting by 0:
  function(e) {
    return `The plugin for '${e}' has not been loaded into Immer. To enable the plugin, import and call \`enable${e}()\` when initializing your application.`;
  },
  function(e) {
    return `produce can only be called on things that are draftable: plain objects, arrays, Map, Set or classes that are marked with '[immerable]: true'. Got '${e}'`;
  },
  "This object has been frozen and should not be mutated",
  function(e) {
    return "Cannot use a proxy that has been revoked. Did you pass an object from inside an immer function to an async process? " + e;
  },
  "An immer producer returned a new value *and* modified its draft. Either return a new value *or* modify the draft.",
  "Immer forbids circular references",
  "The first or second argument to `produce` must be a function",
  "The third argument to `produce` must be a function or undefined",
  "First argument to `createDraft` must be a plain object, an array, or an immerable object",
  "First argument to `finishDraft` must be a draft returned by `createDraft`",
  function(e) {
    return `'current' expects a draft, got: ${e}`;
  },
  "Object.defineProperty() cannot be used on an Immer draft",
  "Object.setPrototypeOf() cannot be used on an Immer draft",
  "Immer only supports deleting array indices",
  "Immer only supports setting array indices and the 'length' property",
  function(e) {
    return `'original' expects a draft, got: ${e}`;
  }
  // Note: if more errors are added, the errorOffset in Patches.ts should be increased
  // See Patches.ts for additional errors
] : [];
function C(e, ...t) {
  if (process.env.NODE_ENV !== "production") {
    const n = tt[e], a = typeof n == "function" ? n.apply(null, t) : n;
    throw new Error(`[Immer] ${a}`);
  }
  throw new Error(
    `[Immer] minified error nr: ${e}. Full error at: https://bit.ly/3cXEKWf`
  );
}
var U = Object.getPrototypeOf;
function Y(e) {
  return !!e && !!e[m];
}
function k(e) {
  var t;
  return e ? dr(e) || Array.isArray(e) || !!e[rr] || !!((t = e.constructor) != null && t[rr]) || ue(e) || ce(e) : !1;
}
var nt = Object.prototype.constructor.toString();
function dr(e) {
  if (!e || typeof e != "object")
    return !1;
  const t = U(e);
  if (t === null)
    return !0;
  const n = Object.hasOwnProperty.call(t, "constructor") && t.constructor;
  return n === Object ? !0 : typeof n == "function" && Function.toString.call(n) === nt;
}
function V(e, t) {
  se(e) === 0 ? Object.entries(e).forEach(([n, a]) => {
    t(n, a, e);
  }) : e.forEach((n, a) => t(a, n, e));
}
function se(e) {
  const t = e[m];
  return t ? t.type_ : Array.isArray(e) ? 1 : ue(e) ? 2 : ce(e) ? 3 : 0;
}
function Ee(e, t) {
  return se(e) === 2 ? e.has(t) : Object.prototype.hasOwnProperty.call(e, t);
}
function pr(e, t, n) {
  const a = se(e);
  a === 2 ? e.set(t, n) : a === 3 ? e.add(n) : e[t] = n;
}
function at(e, t) {
  return e === t ? e !== 0 || 1 / e === 1 / t : e !== e && t !== t;
}
function ue(e) {
  return e instanceof Map;
}
function ce(e) {
  return e instanceof Set;
}
function O(e) {
  return e.copy_ || e.base_;
}
function Re(e, t) {
  if (ue(e))
    return new Map(e);
  if (ce(e))
    return new Set(e);
  if (Array.isArray(e))
    return Array.prototype.slice.call(e);
  if (!t && dr(e))
    return U(e) ? { ...e } : Object.assign(/* @__PURE__ */ Object.create(null), e);
  const n = Object.getOwnPropertyDescriptors(e);
  delete n[m];
  let a = Reflect.ownKeys(n);
  for (let s = 0; s < a.length; s++) {
    const l = a[s], c = n[l];
    c.writable === !1 && (c.writable = !0, c.configurable = !0), (c.get || c.set) && (n[l] = {
      configurable: !0,
      writable: !0,
      // could live with !!desc.set as well here...
      enumerable: c.enumerable,
      value: e[l]
    });
  }
  return Object.create(U(e), n);
}
function Ce(e, t = !1) {
  return fe(e) || Y(e) || !k(e) || (se(e) > 1 && (e.set = e.add = e.clear = e.delete = ot), Object.freeze(e), t && V(e, (n, a) => Ce(a, !0))), e;
}
function ot() {
  C(2);
}
function fe(e) {
  return Object.isFrozen(e);
}
var Pe = {};
function L(e) {
  const t = Pe[e];
  return t || C(0, e), t;
}
function it(e, t) {
  Pe[e] || (Pe[e] = t);
}
var H;
function ae() {
  return H;
}
function st(e, t) {
  return {
    drafts_: [],
    parent_: e,
    immer_: t,
    // Whenever the modified draft contains a draft from another scope, we
    // need to prevent auto-freezing so the unowned draft can be finalized.
    canAutoFreeze_: !0,
    unfinalizedDrafts_: 0
  };
}
function tr(e, t) {
  t && (L("Patches"), e.patches_ = [], e.inversePatches_ = [], e.patchListener_ = t);
}
function Oe(e) {
  we(e), e.drafts_.forEach(ut), e.drafts_ = null;
}
function we(e) {
  e === H && (H = e.parent_);
}
function nr(e) {
  return H = st(H, e);
}
function ut(e) {
  const t = e[m];
  t.type_ === 0 || t.type_ === 1 ? t.revoke_() : t.revoked_ = !0;
}
function ar(e, t) {
  t.unfinalizedDrafts_ = t.drafts_.length;
  const n = t.drafts_[0];
  return e !== void 0 && e !== n ? (n[m].modified_ && (Oe(t), C(4)), k(e) && (e = oe(t, e), t.parent_ || ie(t, e)), t.patches_ && L("Patches").generateReplacementPatches_(
    n[m].base_,
    e,
    t.patches_,
    t.inversePatches_
  )) : e = oe(t, n, []), Oe(t), t.patches_ && t.patchListener_(t.patches_, t.inversePatches_), e !== lr ? e : void 0;
}
function oe(e, t, n) {
  if (fe(t))
    return t;
  const a = t[m];
  if (!a)
    return V(
      t,
      (s, l) => or(e, a, t, s, l, n)
    ), t;
  if (a.scope_ !== e)
    return t;
  if (!a.modified_)
    return ie(e, a.base_, !0), a.base_;
  if (!a.finalized_) {
    a.finalized_ = !0, a.scope_.unfinalizedDrafts_--;
    const s = a.copy_;
    let l = s, c = !1;
    a.type_ === 3 && (l = new Set(s), s.clear(), c = !0), V(
      l,
      (p, o) => or(e, a, s, p, o, n, c)
    ), ie(e, s, !1), n && e.patches_ && L("Patches").generatePatches_(
      a,
      n,
      e.patches_,
      e.inversePatches_
    );
  }
  return a.copy_;
}
function or(e, t, n, a, s, l, c) {
  if (process.env.NODE_ENV !== "production" && s === n && C(5), Y(s)) {
    const p = l && t && t.type_ !== 3 && // Set objects are atomic since they have no keys.
    !Ee(t.assigned_, a) ? l.concat(a) : void 0, o = oe(e, s, p);
    if (pr(n, a, o), Y(o))
      e.canAutoFreeze_ = !1;
    else
      return;
  } else
    c && n.add(s);
  if (k(s) && !fe(s)) {
    if (!e.immer_.autoFreeze_ && e.unfinalizedDrafts_ < 1)
      return;
    oe(e, s), (!t || !t.scope_.parent_) && ie(e, s);
  }
}
function ie(e, t, n = !1) {
  !e.parent_ && e.immer_.autoFreeze_ && e.canAutoFreeze_ && Ce(t, n);
}
function ct(e, t) {
  const n = Array.isArray(e), a = {
    type_: n ? 1 : 0,
    // Track which produce call this is associated with.
    scope_: t ? t.scope_ : ae(),
    // True for both shallow and deep changes.
    modified_: !1,
    // Used during finalization.
    finalized_: !1,
    // Track which properties have been assigned (true) or deleted (false).
    assigned_: {},
    // The parent draft state.
    parent_: t,
    // The base state.
    base_: e,
    // The base proxy.
    draft_: null,
    // set below
    // The base copy with any updated values.
    copy_: null,
    // Called by the `produce` function.
    revoke_: null,
    isManual_: !1
  };
  let s = a, l = Me;
  n && (s = [a], l = X);
  const { revoke: c, proxy: p } = Proxy.revocable(s, l);
  return a.draft_ = p, a.revoke_ = c, p;
}
var Me = {
  get(e, t) {
    if (t === m)
      return e;
    const n = O(e);
    if (!Ee(n, t))
      return ft(e, n, t);
    const a = n[t];
    return e.finalized_ || !k(a) ? a : a === ge(e.base_, t) ? (be(e), e.copy_[t] = Z(a, e)) : a;
  },
  has(e, t) {
    return t in O(e);
  },
  ownKeys(e) {
    return Reflect.ownKeys(O(e));
  },
  set(e, t, n) {
    const a = _r(O(e), t);
    if (a != null && a.set)
      return a.set.call(e.draft_, n), !0;
    if (!e.modified_) {
      const s = ge(O(e), t), l = s == null ? void 0 : s[m];
      if (l && l.base_ === n)
        return e.copy_[t] = n, e.assigned_[t] = !1, !0;
      if (at(n, s) && (n !== void 0 || Ee(e.base_, t)))
        return !0;
      be(e), z(e);
    }
    return e.copy_[t] === n && // special case: handle new props with value 'undefined'
    (n !== void 0 || t in e.copy_) || // special case: NaN
    Number.isNaN(n) && Number.isNaN(e.copy_[t]) || (e.copy_[t] = n, e.assigned_[t] = !0), !0;
  },
  deleteProperty(e, t) {
    return ge(e.base_, t) !== void 0 || t in e.base_ ? (e.assigned_[t] = !1, be(e), z(e)) : delete e.assigned_[t], e.copy_ && delete e.copy_[t], !0;
  },
  // Note: We never coerce `desc.value` into an Immer draft, because we can't make
  // the same guarantee in ES5 mode.
  getOwnPropertyDescriptor(e, t) {
    const n = O(e), a = Reflect.getOwnPropertyDescriptor(n, t);
    return a && {
      writable: !0,
      configurable: e.type_ !== 1 || t !== "length",
      enumerable: a.enumerable,
      value: n[t]
    };
  },
  defineProperty() {
    C(11);
  },
  getPrototypeOf(e) {
    return U(e.base_);
  },
  setPrototypeOf() {
    C(12);
  }
}, X = {};
V(Me, (e, t) => {
  X[e] = function() {
    return arguments[0] = arguments[0][0], t.apply(this, arguments);
  };
});
X.deleteProperty = function(e, t) {
  return process.env.NODE_ENV !== "production" && isNaN(parseInt(t)) && C(13), X.set.call(this, e, t, void 0);
};
X.set = function(e, t, n) {
  return process.env.NODE_ENV !== "production" && t !== "length" && isNaN(parseInt(t)) && C(14), Me.set.call(this, e[0], t, n, e[0]);
};
function ge(e, t) {
  const n = e[m];
  return (n ? O(n) : e)[t];
}
function ft(e, t, n) {
  var s;
  const a = _r(t, n);
  return a ? "value" in a ? a.value : (
    // This is a very special case, if the prop is a getter defined by the
    // prototype, we should invoke it with the draft as context!
    (s = a.get) == null ? void 0 : s.call(e.draft_)
  ) : void 0;
}
function _r(e, t) {
  if (!(t in e))
    return;
  let n = U(e);
  for (; n; ) {
    const a = Object.getOwnPropertyDescriptor(n, t);
    if (a)
      return a;
    n = U(n);
  }
}
function z(e) {
  e.modified_ || (e.modified_ = !0, e.parent_ && z(e.parent_));
}
function be(e) {
  e.copy_ || (e.copy_ = Re(
    e.base_,
    e.scope_.immer_.useStrictShallowCopy_
  ));
}
var lt = class {
  constructor(e) {
    this.autoFreeze_ = !0, this.useStrictShallowCopy_ = !1, this.produce = (t, n, a) => {
      if (typeof t == "function" && typeof n != "function") {
        const l = n;
        n = t;
        const c = this;
        return function(o = l, ...u) {
          return c.produce(o, (d) => n.call(this, d, ...u));
        };
      }
      typeof n != "function" && C(6), a !== void 0 && typeof a != "function" && C(7);
      let s;
      if (k(t)) {
        const l = nr(this), c = Z(t, void 0);
        let p = !0;
        try {
          s = n(c), p = !1;
        } finally {
          p ? Oe(l) : we(l);
        }
        return tr(l, a), ar(s, l);
      } else if (!t || typeof t != "object") {
        if (s = n(t), s === void 0 && (s = t), s === lr && (s = void 0), this.autoFreeze_ && Ce(s, !0), a) {
          const l = [], c = [];
          L("Patches").generateReplacementPatches_(t, s, l, c), a(l, c);
        }
        return s;
      } else
        C(1, t);
    }, this.produceWithPatches = (t, n) => {
      if (typeof t == "function")
        return (c, ...p) => this.produceWithPatches(c, (o) => t(o, ...p));
      let a, s;
      return [this.produce(t, n, (c, p) => {
        a = c, s = p;
      }), a, s];
    }, typeof (e == null ? void 0 : e.autoFreeze) == "boolean" && this.setAutoFreeze(e.autoFreeze), typeof (e == null ? void 0 : e.useStrictShallowCopy) == "boolean" && this.setUseStrictShallowCopy(e.useStrictShallowCopy);
  }
  createDraft(e) {
    k(e) || C(8), Y(e) && (e = dt(e));
    const t = nr(this), n = Z(e, void 0);
    return n[m].isManual_ = !0, we(t), n;
  }
  finishDraft(e, t) {
    const n = e && e[m];
    (!n || !n.isManual_) && C(9);
    const { scope_: a } = n;
    return tr(a, t), ar(void 0, a);
  }
  /**
   * Pass true to automatically freeze all copies created by Immer.
   *
   * By default, auto-freezing is enabled.
   */
  setAutoFreeze(e) {
    this.autoFreeze_ = e;
  }
  /**
   * Pass true to enable strict shallow copy.
   *
   * By default, immer does not copy the object descriptors such as getter, setter and non-enumrable properties.
   */
  setUseStrictShallowCopy(e) {
    this.useStrictShallowCopy_ = e;
  }
  applyPatches(e, t) {
    let n;
    for (n = t.length - 1; n >= 0; n--) {
      const s = t[n];
      if (s.path.length === 0 && s.op === "replace") {
        e = s.value;
        break;
      }
    }
    n > -1 && (t = t.slice(n + 1));
    const a = L("Patches").applyPatches_;
    return Y(e) ? a(e, t) : this.produce(
      e,
      (s) => a(s, t)
    );
  }
};
function Z(e, t) {
  const n = ue(e) ? L("MapSet").proxyMap_(e, t) : ce(e) ? L("MapSet").proxySet_(e, t) : ct(e, t);
  return (t ? t.scope_ : ae()).drafts_.push(n), n;
}
function dt(e) {
  return Y(e) || C(10, e), hr(e);
}
function hr(e) {
  if (!k(e) || fe(e))
    return e;
  const t = e[m];
  let n;
  if (t) {
    if (!t.modified_)
      return t.base_;
    t.finalized_ = !0, n = Re(e, t.scope_.immer_.useStrictShallowCopy_);
  } else
    n = Re(e, !0);
  return V(n, (a, s) => {
    pr(n, a, hr(s));
  }), t && (t.finalized_ = !1), n;
}
function pt() {
  class e extends Map {
    constructor(o, u) {
      super(), this[m] = {
        type_: 2,
        parent_: u,
        scope_: u ? u.scope_ : ae(),
        modified_: !1,
        finalized_: !1,
        copy_: void 0,
        assigned_: void 0,
        base_: o,
        draft_: this,
        isManual_: !1,
        revoked_: !1
      };
    }
    get size() {
      return O(this[m]).size;
    }
    has(o) {
      return O(this[m]).has(o);
    }
    set(o, u) {
      const d = this[m];
      return c(d), (!O(d).has(o) || O(d).get(o) !== u) && (n(d), z(d), d.assigned_.set(o, !0), d.copy_.set(o, u), d.assigned_.set(o, !0)), this;
    }
    delete(o) {
      if (!this.has(o))
        return !1;
      const u = this[m];
      return c(u), n(u), z(u), u.base_.has(o) ? u.assigned_.set(o, !1) : u.assigned_.delete(o), u.copy_.delete(o), !0;
    }
    clear() {
      const o = this[m];
      c(o), O(o).size && (n(o), z(o), o.assigned_ = /* @__PURE__ */ new Map(), V(o.base_, (u) => {
        o.assigned_.set(u, !1);
      }), o.copy_.clear());
    }
    forEach(o, u) {
      const d = this[m];
      O(d).forEach((b, T, B) => {
        o.call(u, this.get(T), T, this);
      });
    }
    get(o) {
      const u = this[m];
      c(u);
      const d = O(u).get(o);
      if (u.finalized_ || !k(d) || d !== u.base_.get(o))
        return d;
      const b = Z(d, u);
      return n(u), u.copy_.set(o, b), b;
    }
    keys() {
      return O(this[m]).keys();
    }
    values() {
      const o = this.keys();
      return {
        [Symbol.iterator]: () => this.values(),
        next: () => {
          const u = o.next();
          return u.done ? u : {
            done: !1,
            value: this.get(u.value)
          };
        }
      };
    }
    entries() {
      const o = this.keys();
      return {
        [Symbol.iterator]: () => this.entries(),
        next: () => {
          const u = o.next();
          if (u.done)
            return u;
          const d = this.get(u.value);
          return {
            done: !1,
            value: [u.value, d]
          };
        }
      };
    }
    [Symbol.iterator]() {
      return this.entries();
    }
  }
  function t(p, o) {
    return new e(p, o);
  }
  function n(p) {
    p.copy_ || (p.assigned_ = /* @__PURE__ */ new Map(), p.copy_ = new Map(p.base_));
  }
  class a extends Set {
    constructor(o, u) {
      super(), this[m] = {
        type_: 3,
        parent_: u,
        scope_: u ? u.scope_ : ae(),
        modified_: !1,
        finalized_: !1,
        copy_: void 0,
        base_: o,
        draft_: this,
        drafts_: /* @__PURE__ */ new Map(),
        revoked_: !1,
        isManual_: !1
      };
    }
    get size() {
      return O(this[m]).size;
    }
    has(o) {
      const u = this[m];
      return c(u), u.copy_ ? !!(u.copy_.has(o) || u.drafts_.has(o) && u.copy_.has(u.drafts_.get(o))) : u.base_.has(o);
    }
    add(o) {
      const u = this[m];
      return c(u), this.has(o) || (l(u), z(u), u.copy_.add(o)), this;
    }
    delete(o) {
      if (!this.has(o))
        return !1;
      const u = this[m];
      return c(u), l(u), z(u), u.copy_.delete(o) || (u.drafts_.has(o) ? u.copy_.delete(u.drafts_.get(o)) : (
        /* istanbul ignore next */
        !1
      ));
    }
    clear() {
      const o = this[m];
      c(o), O(o).size && (l(o), z(o), o.copy_.clear());
    }
    values() {
      const o = this[m];
      return c(o), l(o), o.copy_.values();
    }
    entries() {
      const o = this[m];
      return c(o), l(o), o.copy_.entries();
    }
    keys() {
      return this.values();
    }
    [Symbol.iterator]() {
      return this.values();
    }
    forEach(o, u) {
      const d = this.values();
      let b = d.next();
      for (; !b.done; )
        o.call(u, b.value, b.value, this), b = d.next();
    }
  }
  function s(p, o) {
    return new a(p, o);
  }
  function l(p) {
    p.copy_ || (p.copy_ = /* @__PURE__ */ new Set(), p.base_.forEach((o) => {
      if (k(o)) {
        const u = Z(o, p);
        p.drafts_.set(o, u), p.copy_.add(u);
      } else
        p.copy_.add(o);
    }));
  }
  function c(p) {
    p.revoked_ && C(3, JSON.stringify(O(p)));
  }
  it("MapSet", { proxyMap_: t, proxySet_: s });
}
var M = new lt(), _t = M.produce;
M.produceWithPatches.bind(
  M
);
M.setAutoFreeze.bind(M);
M.setUseStrictShallowCopy.bind(M);
M.applyPatches.bind(M);
M.createDraft.bind(M);
M.finishDraft.bind(M);
var j = {}, ht = {
  get exports() {
    return j;
  },
  set exports(e) {
    j = e;
  }
}, J = {};
/**
 * @license React
 * react-jsx-runtime.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var ir;
function yt() {
  if (ir)
    return J;
  ir = 1;
  var e = ur, t = Symbol.for("react.element"), n = Symbol.for("react.fragment"), a = Object.prototype.hasOwnProperty, s = e.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, l = { key: !0, ref: !0, __self: !0, __source: !0 };
  function c(p, o, u) {
    var d, b = {}, T = null, B = null;
    u !== void 0 && (T = "" + u), o.key !== void 0 && (T = "" + o.key), o.ref !== void 0 && (B = o.ref);
    for (d in o)
      a.call(o, d) && !l.hasOwnProperty(d) && (b[d] = o[d]);
    if (p && p.defaultProps)
      for (d in o = p.defaultProps, o)
        b[d] === void 0 && (b[d] = o[d]);
    return { $$typeof: t, type: p, key: T, ref: B, props: b, _owner: s.current };
  }
  return J.Fragment = n, J.jsx = c, J.jsxs = c, J;
}
var K = {};
/**
 * @license React
 * react-jsx-runtime.development.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var sr;
function vt() {
  return sr || (sr = 1, process.env.NODE_ENV !== "production" && function() {
    var e = ur, t = Symbol.for("react.element"), n = Symbol.for("react.portal"), a = Symbol.for("react.fragment"), s = Symbol.for("react.strict_mode"), l = Symbol.for("react.profiler"), c = Symbol.for("react.provider"), p = Symbol.for("react.context"), o = Symbol.for("react.forward_ref"), u = Symbol.for("react.suspense"), d = Symbol.for("react.suspense_list"), b = Symbol.for("react.memo"), T = Symbol.for("react.lazy"), B = Symbol.for("react.offscreen"), Te = Symbol.iterator, vr = "@@iterator";
    function mr(r) {
      if (r === null || typeof r != "object")
        return null;
      var i = Te && r[Te] || r[vr];
      return typeof i == "function" ? i : null;
    }
    var I = e.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED;
    function w(r) {
      {
        for (var i = arguments.length, f = new Array(i > 1 ? i - 1 : 0), _ = 1; _ < i; _++)
          f[_ - 1] = arguments[_];
        gr("error", r, f);
      }
    }
    function gr(r, i, f) {
      {
        var _ = I.ReactDebugCurrentFrame, v = _.getStackAddendum();
        v !== "" && (i += "%s", f = f.concat([v]));
        var g = f.map(function(y) {
          return String(y);
        });
        g.unshift("Warning: " + i), Function.prototype.apply.call(console[r], console, g);
      }
    }
    var br = !1, Er = !1, Rr = !1, Pr = !1, Or = !1, je;
    je = Symbol.for("react.module.reference");
    function wr(r) {
      return !!(typeof r == "string" || typeof r == "function" || r === a || r === l || Or || r === s || r === u || r === d || Pr || r === B || br || Er || Rr || typeof r == "object" && r !== null && (r.$$typeof === T || r.$$typeof === b || r.$$typeof === c || r.$$typeof === p || r.$$typeof === o || // This needs to include all possible module reference object
      // types supported by any Flight configuration anywhere since
      // we don't know which Flight build this will end up being used
      // with.
      r.$$typeof === je || r.getModuleId !== void 0));
    }
    function Sr(r, i, f) {
      var _ = r.displayName;
      if (_)
        return _;
      var v = i.displayName || i.name || "";
      return v !== "" ? f + "(" + v + ")" : f;
    }
    function Fe(r) {
      return r.displayName || "Context";
    }
    function F(r) {
      if (r == null)
        return null;
      if (typeof r.tag == "number" && w("Received an unexpected object in getComponentNameFromType(). This is likely a bug in React. Please file an issue."), typeof r == "function")
        return r.displayName || r.name || null;
      if (typeof r == "string")
        return r;
      switch (r) {
        case a:
          return "Fragment";
        case n:
          return "Portal";
        case l:
          return "Profiler";
        case s:
          return "StrictMode";
        case u:
          return "Suspense";
        case d:
          return "SuspenseList";
      }
      if (typeof r == "object")
        switch (r.$$typeof) {
          case p:
            var i = r;
            return Fe(i) + ".Consumer";
          case c:
            var f = r;
            return Fe(f._context) + ".Provider";
          case o:
            return Sr(r, r.render, "ForwardRef");
          case b:
            var _ = r.displayName || null;
            return _ !== null ? _ : F(r.type) || "Memo";
          case T: {
            var v = r, g = v._payload, y = v._init;
            try {
              return F(y(g));
            } catch {
              return null;
            }
          }
        }
      return null;
    }
    var A = Object.assign, q = 0, De, ze, ke, Ae, Le, Ne, Ie;
    function $e() {
    }
    $e.__reactDisabledLog = !0;
    function Cr() {
      {
        if (q === 0) {
          De = console.log, ze = console.info, ke = console.warn, Ae = console.error, Le = console.group, Ne = console.groupCollapsed, Ie = console.groupEnd;
          var r = {
            configurable: !0,
            enumerable: !0,
            value: $e,
            writable: !0
          };
          Object.defineProperties(console, {
            info: r,
            log: r,
            warn: r,
            error: r,
            group: r,
            groupCollapsed: r,
            groupEnd: r
          });
        }
        q++;
      }
    }
    function Mr() {
      {
        if (q--, q === 0) {
          var r = {
            configurable: !0,
            enumerable: !0,
            writable: !0
          };
          Object.defineProperties(console, {
            log: A({}, r, {
              value: De
            }),
            info: A({}, r, {
              value: ze
            }),
            warn: A({}, r, {
              value: ke
            }),
            error: A({}, r, {
              value: Ae
            }),
            group: A({}, r, {
              value: Le
            }),
            groupCollapsed: A({}, r, {
              value: Ne
            }),
            groupEnd: A({}, r, {
              value: Ie
            })
          });
        }
        q < 0 && w("disabledDepth fell below zero. This is a bug in React. Please file an issue.");
      }
    }
    var le = I.ReactCurrentDispatcher, de;
    function Q(r, i, f) {
      {
        if (de === void 0)
          try {
            throw Error();
          } catch (v) {
            var _ = v.stack.trim().match(/\n( *(at )?)/);
            de = _ && _[1] || "";
          }
        return `
` + de + r;
      }
    }
    var pe = !1, ee;
    {
      var xr = typeof WeakMap == "function" ? WeakMap : Map;
      ee = new xr();
    }
    function We(r, i) {
      if (!r || pe)
        return "";
      {
        var f = ee.get(r);
        if (f !== void 0)
          return f;
      }
      var _;
      pe = !0;
      var v = Error.prepareStackTrace;
      Error.prepareStackTrace = void 0;
      var g;
      g = le.current, le.current = null, Cr();
      try {
        if (i) {
          var y = function() {
            throw Error();
          };
          if (Object.defineProperty(y.prototype, "props", {
            set: function() {
              throw Error();
            }
          }), typeof Reflect == "object" && Reflect.construct) {
            try {
              Reflect.construct(y, []);
            } catch (D) {
              _ = D;
            }
            Reflect.construct(r, [], y);
          } else {
            try {
              y.call();
            } catch (D) {
              _ = D;
            }
            r.call(y.prototype);
          }
        } else {
          try {
            throw Error();
          } catch (D) {
            _ = D;
          }
          r();
        }
      } catch (D) {
        if (D && _ && typeof D.stack == "string") {
          for (var h = D.stack.split(`
`), S = _.stack.split(`
`), E = h.length - 1, R = S.length - 1; E >= 1 && R >= 0 && h[E] !== S[R]; )
            R--;
          for (; E >= 1 && R >= 0; E--, R--)
            if (h[E] !== S[R]) {
              if (E !== 1 || R !== 1)
                do
                  if (E--, R--, R < 0 || h[E] !== S[R]) {
                    var x = `
` + h[E].replace(" at new ", " at ");
                    return r.displayName && x.includes("<anonymous>") && (x = x.replace("<anonymous>", r.displayName)), typeof r == "function" && ee.set(r, x), x;
                  }
                while (E >= 1 && R >= 0);
              break;
            }
        }
      } finally {
        pe = !1, le.current = g, Mr(), Error.prepareStackTrace = v;
      }
      var W = r ? r.displayName || r.name : "", er = W ? Q(W) : "";
      return typeof r == "function" && ee.set(r, er), er;
    }
    function Tr(r, i, f) {
      return We(r, !1);
    }
    function jr(r) {
      var i = r.prototype;
      return !!(i && i.isReactComponent);
    }
    function re(r, i, f) {
      if (r == null)
        return "";
      if (typeof r == "function")
        return We(r, jr(r));
      if (typeof r == "string")
        return Q(r);
      switch (r) {
        case u:
          return Q("Suspense");
        case d:
          return Q("SuspenseList");
      }
      if (typeof r == "object")
        switch (r.$$typeof) {
          case o:
            return Tr(r.render);
          case b:
            return re(r.type, i, f);
          case T: {
            var _ = r, v = _._payload, g = _._init;
            try {
              return re(g(v), i, f);
            } catch {
            }
          }
        }
      return "";
    }
    var te = Object.prototype.hasOwnProperty, Ue = {}, Ye = I.ReactDebugCurrentFrame;
    function ne(r) {
      if (r) {
        var i = r._owner, f = re(r.type, r._source, i ? i.type : null);
        Ye.setExtraStackFrame(f);
      } else
        Ye.setExtraStackFrame(null);
    }
    function Fr(r, i, f, _, v) {
      {
        var g = Function.call.bind(te);
        for (var y in r)
          if (g(r, y)) {
            var h = void 0;
            try {
              if (typeof r[y] != "function") {
                var S = Error((_ || "React class") + ": " + f + " type `" + y + "` is invalid; it must be a function, usually from the `prop-types` package, but received `" + typeof r[y] + "`.This often happens because of typos such as `PropTypes.function` instead of `PropTypes.func`.");
                throw S.name = "Invariant Violation", S;
              }
              h = r[y](i, y, _, f, null, "SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED");
            } catch (E) {
              h = E;
            }
            h && !(h instanceof Error) && (ne(v), w("%s: type specification of %s `%s` is invalid; the type checker function must return `null` or an `Error` but returned a %s. You may have forgotten to pass an argument to the type checker creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and shape all require an argument).", _ || "React class", f, y, typeof h), ne(null)), h instanceof Error && !(h.message in Ue) && (Ue[h.message] = !0, ne(v), w("Failed %s type: %s", f, h.message), ne(null));
          }
      }
    }
    var Dr = Array.isArray;
    function _e(r) {
      return Dr(r);
    }
    function zr(r) {
      {
        var i = typeof Symbol == "function" && Symbol.toStringTag, f = i && r[Symbol.toStringTag] || r.constructor.name || "Object";
        return f;
      }
    }
    function kr(r) {
      try {
        return Ve(r), !1;
      } catch {
        return !0;
      }
    }
    function Ve(r) {
      return "" + r;
    }
    function Be(r) {
      if (kr(r))
        return w("The provided key is an unsupported type %s. This value must be coerced to a string before before using it here.", zr(r)), Ve(r);
    }
    var G = I.ReactCurrentOwner, Ar = {
      key: !0,
      ref: !0,
      __self: !0,
      __source: !0
    }, qe, Ge, he;
    he = {};
    function Lr(r) {
      if (te.call(r, "ref")) {
        var i = Object.getOwnPropertyDescriptor(r, "ref").get;
        if (i && i.isReactWarning)
          return !1;
      }
      return r.ref !== void 0;
    }
    function Nr(r) {
      if (te.call(r, "key")) {
        var i = Object.getOwnPropertyDescriptor(r, "key").get;
        if (i && i.isReactWarning)
          return !1;
      }
      return r.key !== void 0;
    }
    function Ir(r, i) {
      if (typeof r.ref == "string" && G.current && i && G.current.stateNode !== i) {
        var f = F(G.current.type);
        he[f] || (w('Component "%s" contains the string ref "%s". Support for string refs will be removed in a future major release. This case cannot be automatically converted to an arrow function. We ask you to manually fix this case by using useRef() or createRef() instead. Learn more about using refs safely here: https://reactjs.org/link/strict-mode-string-ref', F(G.current.type), r.ref), he[f] = !0);
      }
    }
    function $r(r, i) {
      {
        var f = function() {
          qe || (qe = !0, w("%s: `key` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", i));
        };
        f.isReactWarning = !0, Object.defineProperty(r, "key", {
          get: f,
          configurable: !0
        });
      }
    }
    function Wr(r, i) {
      {
        var f = function() {
          Ge || (Ge = !0, w("%s: `ref` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", i));
        };
        f.isReactWarning = !0, Object.defineProperty(r, "ref", {
          get: f,
          configurable: !0
        });
      }
    }
    var Ur = function(r, i, f, _, v, g, y) {
      var h = {
        // This tag allows us to uniquely identify this as a React Element
        $$typeof: t,
        // Built-in properties that belong on the element
        type: r,
        key: i,
        ref: f,
        props: y,
        // Record the component responsible for creating this element.
        _owner: g
      };
      return h._store = {}, Object.defineProperty(h._store, "validated", {
        configurable: !1,
        enumerable: !1,
        writable: !0,
        value: !1
      }), Object.defineProperty(h, "_self", {
        configurable: !1,
        enumerable: !1,
        writable: !1,
        value: _
      }), Object.defineProperty(h, "_source", {
        configurable: !1,
        enumerable: !1,
        writable: !1,
        value: v
      }), Object.freeze && (Object.freeze(h.props), Object.freeze(h)), h;
    };
    function Yr(r, i, f, _, v) {
      {
        var g, y = {}, h = null, S = null;
        f !== void 0 && (Be(f), h = "" + f), Nr(i) && (Be(i.key), h = "" + i.key), Lr(i) && (S = i.ref, Ir(i, v));
        for (g in i)
          te.call(i, g) && !Ar.hasOwnProperty(g) && (y[g] = i[g]);
        if (r && r.defaultProps) {
          var E = r.defaultProps;
          for (g in E)
            y[g] === void 0 && (y[g] = E[g]);
        }
        if (h || S) {
          var R = typeof r == "function" ? r.displayName || r.name || "Unknown" : r;
          h && $r(y, R), S && Wr(y, R);
        }
        return Ur(r, h, S, v, _, G.current, y);
      }
    }
    var ye = I.ReactCurrentOwner, Je = I.ReactDebugCurrentFrame;
    function $(r) {
      if (r) {
        var i = r._owner, f = re(r.type, r._source, i ? i.type : null);
        Je.setExtraStackFrame(f);
      } else
        Je.setExtraStackFrame(null);
    }
    var ve;
    ve = !1;
    function me(r) {
      return typeof r == "object" && r !== null && r.$$typeof === t;
    }
    function Ke() {
      {
        if (ye.current) {
          var r = F(ye.current.type);
          if (r)
            return `

Check the render method of \`` + r + "`.";
        }
        return "";
      }
    }
    function Vr(r) {
      {
        if (r !== void 0) {
          var i = r.fileName.replace(/^.*[\\\/]/, ""), f = r.lineNumber;
          return `

Check your code at ` + i + ":" + f + ".";
        }
        return "";
      }
    }
    var He = {};
    function Br(r) {
      {
        var i = Ke();
        if (!i) {
          var f = typeof r == "string" ? r : r.displayName || r.name;
          f && (i = `

Check the top-level render call using <` + f + ">.");
        }
        return i;
      }
    }
    function Xe(r, i) {
      {
        if (!r._store || r._store.validated || r.key != null)
          return;
        r._store.validated = !0;
        var f = Br(i);
        if (He[f])
          return;
        He[f] = !0;
        var _ = "";
        r && r._owner && r._owner !== ye.current && (_ = " It was passed a child from " + F(r._owner.type) + "."), $(r), w('Each child in a list should have a unique "key" prop.%s%s See https://reactjs.org/link/warning-keys for more information.', f, _), $(null);
      }
    }
    function Ze(r, i) {
      {
        if (typeof r != "object")
          return;
        if (_e(r))
          for (var f = 0; f < r.length; f++) {
            var _ = r[f];
            me(_) && Xe(_, i);
          }
        else if (me(r))
          r._store && (r._store.validated = !0);
        else if (r) {
          var v = mr(r);
          if (typeof v == "function" && v !== r.entries)
            for (var g = v.call(r), y; !(y = g.next()).done; )
              me(y.value) && Xe(y.value, i);
        }
      }
    }
    function qr(r) {
      {
        var i = r.type;
        if (i == null || typeof i == "string")
          return;
        var f;
        if (typeof i == "function")
          f = i.propTypes;
        else if (typeof i == "object" && (i.$$typeof === o || // Note: Memo only checks outer props here.
        // Inner props are checked in the reconciler.
        i.$$typeof === b))
          f = i.propTypes;
        else
          return;
        if (f) {
          var _ = F(i);
          Fr(f, r.props, "prop", _, r);
        } else if (i.PropTypes !== void 0 && !ve) {
          ve = !0;
          var v = F(i);
          w("Component %s declared `PropTypes` instead of `propTypes`. Did you misspell the property assignment?", v || "Unknown");
        }
        typeof i.getDefaultProps == "function" && !i.getDefaultProps.isReactClassApproved && w("getDefaultProps is only used on classic React.createClass definitions. Use a static property named `defaultProps` instead.");
      }
    }
    function Gr(r) {
      {
        for (var i = Object.keys(r.props), f = 0; f < i.length; f++) {
          var _ = i[f];
          if (_ !== "children" && _ !== "key") {
            $(r), w("Invalid prop `%s` supplied to `React.Fragment`. React.Fragment can only have `key` and `children` props.", _), $(null);
            break;
          }
        }
        r.ref !== null && ($(r), w("Invalid attribute `ref` supplied to `React.Fragment`."), $(null));
      }
    }
    function Qe(r, i, f, _, v, g) {
      {
        var y = wr(r);
        if (!y) {
          var h = "";
          (r === void 0 || typeof r == "object" && r !== null && Object.keys(r).length === 0) && (h += " You likely forgot to export your component from the file it's defined in, or you might have mixed up default and named imports.");
          var S = Vr(v);
          S ? h += S : h += Ke();
          var E;
          r === null ? E = "null" : _e(r) ? E = "array" : r !== void 0 && r.$$typeof === t ? (E = "<" + (F(r.type) || "Unknown") + " />", h = " Did you accidentally export a JSX literal instead of a component?") : E = typeof r, w("React.jsx: type is invalid -- expected a string (for built-in components) or a class/function (for composite components) but got: %s.%s", E, h);
        }
        var R = Yr(r, i, f, v, g);
        if (R == null)
          return R;
        if (y) {
          var x = i.children;
          if (x !== void 0)
            if (_)
              if (_e(x)) {
                for (var W = 0; W < x.length; W++)
                  Ze(x[W], r);
                Object.freeze && Object.freeze(x);
              } else
                w("React.jsx: Static children should always be an array. You are likely explicitly calling React.jsxs or React.jsxDEV. Use the Babel transform instead.");
            else
              Ze(x, r);
        }
        return r === a ? Gr(R) : qr(R), R;
      }
    }
    function Jr(r, i, f) {
      return Qe(r, i, f, !0);
    }
    function Kr(r, i, f) {
      return Qe(r, i, f, !1);
    }
    var Hr = Kr, Xr = Jr;
    K.Fragment = a, K.jsx = Hr, K.jsxs = Xr;
  }()), K;
}
(function(e) {
  process.env.NODE_ENV === "production" ? e.exports = yt() : e.exports = vt();
})(ht);
var P = /* @__PURE__ */ ((e) => (e.OpenModal = "OpenModal", e.UpdateModal = "UpdateModal", e.CloseModal = "CloseModal", e.CloseAllModals = "CloseAllModals", e.RemoveModal = "RemoveModal", e.RegisterModal = "RegisterModal", e.LazyModalLoaded = "LazyModalLoaded", e.LoadLazyModal = "LoadLazyModal", e))(P || {});
const yr = /* @__PURE__ */ new Map(), mt = _t(
  (e, t) => {
    const { id: n, props: a, component: s, loadFailed: l, loaded: c, __mergeProps___: p } = t.payload ?? {}, o = Array.from(e.keys()), u = e.has(n);
    let d = e.get(n);
    switch (t.type) {
      case P.OpenModal:
        return d && (d.visible = !0, d.props = Object.assign({}, a ?? {}), e.set(n, d)), e;
      case P.UpdateModal:
        if (d && d.visible) {
          let b = {};
          p && (b = d.props ?? {}), d.props = Object.assign({}, b, a ?? {}), e.set(n, d);
        }
        return e;
      case P.CloseModal:
        return d && (d.visible = !1, e.set(n, d)), e;
      case P.CloseAllModals:
        return o.forEach((b) => {
          d = e.get(b), d.visible = !1, e.set(b, d);
        }), e;
      case P.RegisterModal:
        return u || e.set(n, {
          ...t.payload,
          id: n,
          props: {}
        }), e;
      case P.RemoveModal:
        return e.delete(n), e;
      case P.LoadLazyModal:
        return d && (d.loading = !0, d.loadFailed = !1), e;
      case P.LazyModalLoaded:
        return d && (d.loaded = c, d.loadFailed = l, d.loading = !1, d.component = s, e.set(n, d)), e;
      default:
        return e;
    }
  }
), gt = ({
  render: e,
  visible: t,
  renderProps: n
}) => {
  if (!t || !e)
    return null;
  const a = Object.assign({}, n ?? {}, { visible: t });
  return /* @__PURE__ */ j.jsx(j.Fragment, { children: e(a) });
}, bt = () => {
  const { state: e, dispatch: t, defaultProps: n } = N(), a = Se(() => {
    const s = e.values(), l = [];
    for (const c of s)
      c.component && l.push(Zr(gt, {
        ...n || {},
        render: c.component,
        renderProps: c.props,
        visible: c.visible,
        key: c.id
      }));
    return l;
  }, [e]);
  return cr(() => {
    const s = e.values();
    for (const l of s)
      if (l.isLazy && !l.loaded) {
        t(P.LoadLazyModal, {
          id: l.id
        });
        const c = l.loader;
        c == null || c().then((p) => {
          t(P.LazyModalLoaded, {
            id: l.id,
            component: p.default,
            loadFailed: !1,
            loaded: !0
          });
        });
      }
  }, [e]), /* @__PURE__ */ j.jsx(j.Fragment, { children: a });
}, xe = Qr({
  state: yr,
  dispatch: () => {
  },
  defaultProps: {}
});
xe.displayName = "UMContext";
const Rt = ({ children: e, defaultProps: t = {} }) => {
  const [n, a] = et(mt, yr), s = fr((c, p) => {
    a({ type: c, payload: p });
  }, []), l = {
    state: n,
    defaultProps: t,
    dispatch: s
  };
  return /* @__PURE__ */ j.jsx(xe.Provider, { value: l, children: /* @__PURE__ */ j.jsxs(j.Fragment, { children: [
    /* @__PURE__ */ j.jsx(bt, {}),
    e
  ] }) });
}, N = () => rt(xe), Pt = () => {
  const { state: e, dispatch: t, defaultProps: n } = N();
  return (s, l) => {
    const c = e.get(s), p = l ?? {};
    if (c != null && c.isLazy && !(c != null && c.loaded) && !c.loading) {
      const o = c.loader;
      t(P.LoadLazyModal, {
        id: s
      }), o == null || o().then((u) => {
        t(P.LazyModalLoaded, {
          id: c.id,
          component: u.default,
          loadFailed: !1,
          loaded: !0
        }), setTimeout(() => {
          t(P.OpenModal, {
            id: s,
            props: Object.assign({}, n, p)
          });
        }, 30);
      });
      return;
    }
    t(P.OpenModal, {
      id: s,
      props: Object.assign({}, n, p)
    });
  };
}, Ot = () => {
  const { dispatch: e } = N();
  return {
    closeModal: (a) => e(P.CloseModal, { id: a }),
    closeAllModals: () => e(P.CloseAllModals)
  };
}, wt = () => {
  const { state: e, dispatch: t, defaultProps: n } = N();
  return fr((s, l, c) => {
    t(P.UpdateModal, {
      id: s,
      props: Object.assign({}, n, l),
      __mergeProps___: c
    });
  }, [e]);
}, St = (e) => {
  const { state: t } = N();
  return Se(() => {
    const a = (Array.isArray(e) ? e : [e]).map((s) => t.get(s)).filter(Boolean);
    return a.length ? a.some((s) => s != null && s.isLazy ? s.loading : !1) : !1;
  }, [t, e]);
}, Ct = (e) => {
  const { dispatch: t, state: n } = N(), a = Se(() => Object.keys(e).reduce((s, l) => n.get(l) ? s : {
    ...s,
    [l]: e[l]
  }, {}), [e, n]);
  cr(() => {
    Object.keys(a).forEach((s) => {
      const l = a[s], c = {
        id: s,
        isLazy: l.isLazy,
        component: l.component,
        loader: l.loader
      };
      c.isLazy && (c.loaded = !1, c.loading = !1, c.loadFailed = !1), t(P.RegisterModal, c);
    });
  }, [a]);
}, Mt = () => {
  const { state: e } = N();
  return (t) => {
    var n;
    return (n = e[t]) == null ? void 0 : n.props;
  };
};
pt();
export {
  Rt as ModalProvider,
  Ot as useCloseModal,
  St as useModalIsLoading,
  Mt as useModalProps,
  Pt as useOpenModal,
  Ct as useRegisterModal,
  wt as useUpdateModal
};
